package com.huimv.env.admin.controller;



import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.entity.EnergyElectricity;
import com.huimv.env.common.entity.EnergyEnvDevice;
import com.huimv.env.common.entity.EnergyWater;
import com.huimv.env.common.service.IEnergyElectricityService;
import com.huimv.env.common.service.IEnergyEnvDeviceService;
import com.huimv.env.common.service.IEnergyWaterService;
import com.huimv.env.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@RestController
@RequestMapping("/energy-water")
@CrossOrigin
public class EnergyWaterController {

    @Autowired
    private IEnergyWaterService energyWaterService;
    @Autowired
    private IEnergyEnvDeviceService envDeviceService;
    @Autowired
    private IEnergyElectricityService electricityService;

    @RequestMapping("/listPigpen")
    public Result listPigpen(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyWaterService.listPigpen(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listData")
    public Result listData(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyWaterService.listData(httpServletRequest, paramsMap);
    }

    @RequestMapping("/editTest")
    public void editTest(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String startDate = paramsMap.get("startDate");
        String endDate = paramsMap.get("endDate");
        String type = paramsMap.get("type");
        QueryWrapper<EnergyEnvDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).eq("device_type", type);
        List<EnergyEnvDevice> list = envDeviceService.list(queryWrapper);
        for (EnergyEnvDevice energyEnvDevice : list) {
            QueryWrapper<EnergyElectricity> queryWrapper1 = new QueryWrapper<>();
            queryWrapper1.eq("farm_id", farmId).eq("chip_code", energyEnvDevice.getDeviceCode())
                    .between("create_date", startDate, endDate);
            List<EnergyElectricity> waters = electricityService.list(queryWrapper1);
            for (EnergyElectricity water : waters) {
                water.setOther1(energyEnvDevice.getDeviceName());
                electricityService.updateById(water);
            }
        }
    }

}
